/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License. 
 */

package org.dashbuilder.renderer.c3.client.charts.map.geojson.impl;

import com.google.gwt.json.client.JSONParser;
import com.google.gwt.json.client.JSONValue;
import jsinterop.base.Js;
import org.dashbuilder.renderer.c3.client.charts.map.geojson.GeoJsonLoader;
import org.dashbuilder.renderer.c3.client.exports.NativeLibraryResources;
import org.dashbuilder.renderer.c3.client.jsbinding.geojson.FeatureCollection;

public class GWTGeoJsonLoader implements GeoJsonLoader {

    @Override
    public FeatureCollection load() {
        String geoJsonStr = NativeLibraryResources.INSTANCE.countriesgeojson().getText();
        JSONValue geoJsonObject = JSONParser.parseStrict(geoJsonStr);
        return Js.cast(geoJsonObject.isObject().getJavaScriptObject());
    }

}